﻿using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Pdf.Parsing;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace ImageSample.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            return View();
        }
        public ActionResult CreateDocument()
        {
            //Load the existing PDF document 
            PdfLoadedDocument pdfDocument = new PdfLoadedDocument(Server.MapPath("/App_Data/test.pdf"));

            PdfImage image;

            string fileName = "imageTest.png";

            //Get base 64 string 
            string base64String = GetBase64String(fileName);

            //Convert the string to byte array 
            byte[] data = Convert.FromBase64String(base64String);

            //Get the image
            using (MemoryStream imageStream = new MemoryStream(data, 0, data.Length))
            {
                image = PdfImage.FromStream(imageStream);
            }

            PdfLoadedPage pdfPage = (PdfLoadedPage)pdfDocument.Pages[0];

            if (pdfPage != null)
            {
                PdfGraphics graphics = pdfPage.Graphics;
                graphics.DrawImage(image, 0, 0);
            }

            // Open the document in browser after saving it
            pdfDocument.Save("Output.pdf", HttpContext.ApplicationInstance.Response, HttpReadType.Save);

            return null;
        }

        private string GetBase64String(string imageFile)
        {
            //Load the image
            FileStream fileStream = new FileStream(Server.MapPath("/App_Data/" + imageFile), FileMode.Open, FileAccess.Read);
            MemoryStream stream = new MemoryStream();
            //Copy the image stream
            fileStream.CopyTo(stream);
            //Get image bytes
            byte[] imageByte = stream.ToArray();
            //Coverts an array to base 64 string 
            String imageString = Convert.ToBase64String(imageByte);

            return imageString;
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your application description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }
}